﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Drawing;
using FarPoint.Web.Spread;

namespace CascadeComboBox
{
    public partial class WebForm1 : System.Web.UI.Page
    {
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            FpSpread1.ClientAutoCalculation = true;
            FpSpread1.ActiveSheetView.AllowPage = false;
            FpSpread1.ActiveSheetView.RowCount = 10;
            FpSpread1.ActiveSheetView.ColumnCount = 6;
            FpSpread1.ActiveSheetView.Columns[0].Label = "类别";
            FpSpread1.ActiveSheetView.Columns[0].Width = 150;
            FpSpread1.ActiveSheetView.Columns[1].Label = "名称";
            FpSpread1.ActiveSheetView.Columns[1].Width = 300;
            FpSpread1.ActiveSheetView.Columns[2].Label = "单价";
            FpSpread1.ActiveSheetView.Columns[2].Width = 100;
            FpSpread1.ActiveSheetView.Columns[3].Label = "数量";
            FpSpread1.ActiveSheetView.Columns[3].Width = 100;
            FpSpread1.ActiveSheetView.Columns[4].Label = "折扣";
            FpSpread1.ActiveSheetView.Columns[4].Width = 100;
            FpSpread1.ActiveSheetView.Columns[5].Locked = true;
            FpSpread1.ActiveSheetView.Columns[5].Label = "小计";
            FpSpread1.ActiveSheetView.Columns[5].Width = 200;
            FpSpread1.ActiveSheetView.Columns[5].Formula = "C1 * D1 * E1";
            FpSpread1.ActiveSheetView.Columns[5].CellType = new CurrencyCellType();

            // 指定产品类别列的CellType
            DataSet ds = GetDataSource();
            FarPoint.Web.Spread.ComboBoxCellType ctCategory = new FarPoint.Web.Spread.ComboBoxCellType();
            ctCategory.DataSource = ds;
            ctCategory.DataMember = "Category";
            ctCategory.DataTextField = "Name";
            ctCategory.DataValueField = "ID";
            ctCategory.UseValue = true;
            ctCategory.OnClientChanged = "return CategoryChanged();";

            FpSpread1.ActiveSheetView.Columns[0].CellType = ctCategory;
        }
    }

    /// <summary>
    /// Spread ButtonCommand 事件的处理函数，根据e.CommandName的值来决定相应的处理逻辑
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void FpSpread1_ButtonCommand(object sender, FarPoint.Web.Spread.SpreadCommandEventArgs e)
    {
        switch (e.CommandName)
        {
            case "CategoryChanged":

                // 取到选择的产品类别，作为产品名称列的查询条件
                Point cell = (Point)e.CommandArgument;
                int categoryid = Convert.ToInt32(this.FpSpread1.ActiveSheetView.Cells[cell.X, cell.Y].Value.ToString());

                // 指定产品列相应单元格的CellType
                DataSet ds = GetDataSource();
                DataView product = ds.Tables["Products"].DefaultView;
                product.RowFilter = string.Format("CategoryID = {0}", categoryid);
                ComboBoxCellType ctProduct = new FarPoint.Web.Spread.ComboBoxCellType();        
                ctProduct.DataSource = product;
                ctProduct.DataTextField = "Name";
                ctProduct.DataValueField = "ID";
                ctProduct.UseValue = true;
                FpSpread1.ActiveSheetView.Cells[cell.X, cell.Y + 1].CellType = ctProduct;

                break;
            default:
                break;
        }

    }

        /// <summary>
        /// 返回数据源
        /// </summary>
        /// <returns></returns>
        private DataSet GetDataSource()
        {
            DataSet ds = new DataSet();

            DataTable dt1 = new DataTable();
            dt1.TableName = "Category";
            dt1.Columns.Add("ID");
            dt1.Columns.Add("Name");
            dt1.Rows.Add(1, "控件套包");
            dt1.Rows.Add(2, "表格控件");
            dt1.Rows.Add(3, "报表控件");
            dt1.Rows.Add(4, "商业智能");
            dt1.Rows.Add(5, "图表控件");
            dt1.Rows.Add(6, "文章处理控件");

            ds.Tables.Add(dt1);

            DataTable dt2 = new DataTable();
            dt2.TableName = "Products";
            dt2.Columns.Add("ID");
            dt2.Columns.Add("CategoryID");
            dt2.Columns.Add("Name");
            dt2.Columns.Add("Price");
            dt2.Rows.Add(1, 1, "ComponentOne Ultimate");
            dt2.Rows.Add(2, 1, "ComponentOne Studio Enterprise");
            dt2.Rows.Add(3, 1, "ComponentOne Studio for WinForms");
            dt2.Rows.Add(4, 1, "ComponentOne Studio for ASP.NET Wijmo");
            dt2.Rows.Add(5, 1, "ComponentOne Studio for Silverlight");
            dt2.Rows.Add(6, 1, "ComponentOne Studio for WPF");
            dt2.Rows.Add(7, 1, "ComponentOne Studio for ActiveX ");
            dt2.Rows.Add(8, 1, "ComponentOne Studio for Windows Phone ");
            dt2.Rows.Add(9, 1, "ComponentOne Studio for Compact Framework");
            dt2.Rows.Add(10, 1, "ComponentOne Studio for iPhone");
            dt2.Rows.Add(11, 2, "Spread.NET");
            dt2.Rows.Add(12, 2, "Spread for WinForms");
            dt2.Rows.Add(13, 2, "MultiRow For WinForms");
            dt2.Rows.Add(14, 2, "ComponentOne FlexGrid for WinForms");
            dt2.Rows.Add(15, 2, "Spread COM");
            dt2.Rows.Add(16, 2, "PowerTools智能报表方案");
            dt2.Rows.Add(17, 3, "ActiveReports");
            dt2.Rows.Add(18, 3, "PowerTools智能报表方案");
            dt2.Rows.Add(19, 3, "ActiveReports COM");
            dt2.Rows.Add(20, 4, "ActiveAnalysis ");
            dt2.Rows.Add(21, 4, "PowerTools智能报表方案 ");
            dt2.Rows.Add(22, 5, "ComponentOne Chart for WinForms");
            dt2.Rows.Add(23, 5, "ComponentOne WebChart for ASP.NET ");
            dt2.Rows.Add(24, 5, "Spread.NET ");
            dt2.Rows.Add(25, 5, "Spread for Windows Forms ");
            dt2.Rows.Add(26, 6, "TX Text Control .NET for Windows Forms ");
            dt2.Rows.Add(27, 6, "TX Text Control .NET for WPF ");
            dt2.Rows.Add(28, 6, "TX Text Control Server for ASP.NET (incl. Windows Forms)");
            dt2.Rows.Add(29, 6, "TX Text Control Server for ASP.NET (incl. WPF)");
            dt2.Rows.Add(30, 6, "TX Text Control ActiveX");
            dt2.Rows.Add(31, 6, "TX Text Control ActiveX Server");
            dt2.Rows.Add(32, 6, "GcOffice文档编辑套包 ");
            ds.Tables.Add(dt2);

            return ds;
        }

    }
}